import { defineConfig } from '@rsbuild/core';
import { pluginReact } from '@rsbuild/plugin-react';
import { pluginUmd } from '@rsbuild/plugin-umd';
import path from "path";
// import { pluginNodePolyfill } from '@rsbuild/plugin-node-polyfill';
const nodeEnv = process.env.NODE_ENV === 'production' ? '"production"' : '"development"';
export default defineConfig({
  plugins: [
    // pluginNodePolyfill(),
    pluginReact(),
    pluginUmd({
      name: 'LogicflowRender',
    })
  ],
  source: {
    alias: {
      '@': './src/',
    },
    entry: {
      // index: path.resolve(__dirname, './src/index.tsx')
      index: path.resolve(__dirname, './src/index.tsx')
    },
    define: { 'process.env.NODE_ENV': nodeEnv },
    transformImport: [
    ],
  },
  tools: {
    rspack: {
      optimization: {
        sideEffects: true,
      },
      /*experiments: {
        rspackFuture: {
          newTreeshaking: true,
        },
      },*/
    },
    //
  },
  output: {
    minify: true,
    inlineStyles: true,
    polyfill: 'usage',
    // legalComments: 'none',
    filename: {
      js: `umd.js`,
    },
    externals: {
      react: "React",
      "react-dom": "ReactDOM",
    },
    sourceMap: {
      css: false,
      js: false
    },
  },
  html: {
    template: './index.html'
  }
});
